! Server routines for FlatButtons
! Copyright: DataMatrix Software 1997
!
!    Author: Brian Staff
!            DataMatrix Software
!            893 Beaconsfield Road
!            North Vancouver, BC
!            Canada, V7R 1S7
!
!            Compuserve : 75310,1147
!              Internet : 75310.1147@compuserve.com)
  MEMBER
  MAP
  END
  INCLUDE('FltBtn.INC')
  INCLUDE('ABToolBa.INC')

FlatButtonClassType.Init   PROCEDURE(*BYTE Sw,LONG FirstControl,LONG LastControl,BYTE ToolBar)
bsIndex LONG
  CODE
  !message('first='& firstcontrol & ' last=' & lastcontrol)
  SELF.QC &= NEW(QCT)
  FREE(SELF.QC)
  LOOP bsIndex = FirstControl TO LastControl
      !message('button ' & bsindex & ' tpye=' & bsIndex{PROP:Type} & ' icon='& bsindex{PROP:Icon})
    IF   (bsIndex{PROP:Type}   = CREATE:Button   | !looking for a BUTTON control
      OR  bsIndex{PROP:Type}   = CREATE:Radio    | !or Check or Radio with an icon
      OR  bsIndex{PROP:Type}   = CREATE:Check)   |
      AND bsIndex{PROP:Icon}
      SELF.QC.Beq = bsIndex
      ADD(SELF.QC)
    END
  END
  !message('qrecs=' & RECORDS(SELF.QC))
  IF ToolBar = True                                !Clarion Toolbar Browse buttons on FRAME
    LOOP bsIndex = ToolBar:First TO ToolBar:Last
      SELF.QC.Beq = bsIndex
      ADD(SELF.QC)
    END
  END
  SELF.OnOff       &= Sw                           !Save initial setting
  SELF.LastStatus   = BXOR(SELF.OnOff,0001b)       !Force display
  SELF.Show()
  RETURN

FlatButtonClassType.Show   PROCEDURE()
bsIndex LONG
bsQrecs LONG
  CODE
  IF SELF.OnOff <> SELF.LastStatus
    SELF.LastStatus = SELF.OnOff
    bsQrecs         = RECORDS(SELF.QC)
    LOOP bsIndex = 1 TO bsQrecs           !loop through all controls
      GET(SELF.QC,bsIndex)
      SELF.QC.Beq{PROP:Flat} = SELF.OnOff
    END
  END
  RETURN

FlatButtonClassType.Kill   PROCEDURE()
  CODE
  FREE(SELF.QC)
  DISPOSE(SELF.QC)
  RETURN
!=================================================================
